#include <SimpleKalmanFilter.h>
#include <Stepper.h>
#define STEPS 2048 
#define NUMSTEPS 75
Stepper stepper(STEPS, 21, 8, 20, 9);

long result;   
int analog_pin = A2; 
int tx_pin = A3;  

SimpleKalmanFilter simpleKalmanFilter(50, 50, 0.001);


void setup() {
pinMode(tx_pin,OUTPUT);      
Serial.begin(115200);
stepper.setSpeed(25);

}


long tx_rx(){         
  
  int read_high;
  int read_low;
  int diff;
  long int sum;
  int N_samples = 100;    

  sum = 0;

  for (int i = 0; i < N_samples; i++){
   digitalWrite(tx_pin,HIGH);              
   read_high = analogRead(analog_pin);     
   delayMicroseconds(500);         
   digitalWrite(tx_pin,LOW);            
   read_low = analogRead(analog_pin);         
   diff = read_high - read_low;       
 sum += diff;                       
 }
  return sum;
}                         


void loop() {
stepper.step(NUMSTEPS);

result = tx_rx();

float estimated_value = simpleKalmanFilter.updateEstimate(result);

Serial.println(estimated_value);

}
